<?php
class rubric
{
	var $db;
	
	function rubric ()
	{
		$this->db=new_db_class("db_conf_footrack.php");		
		$this->db->db_connect();
		
	}
	
	function close_db()
	{
		$this->db->db_close();
	}
	
	function get_rubric_name($rubric_id)
	{
		$req=
		"select 
			ru_rubric_name
		from 	
			rubric 
		where 
			ru_rubric_id=$rubric_id 
		limit 1
		;";
	
		$result=$this->db->db_exec($req);
		$nbr_row=$this->db->db_num_rows($result);
		if ($nbr_row != 0)
		{
			$ligne=$this->db->db_fetch_array($result);
			$this->db->db_free_result($result);
			return array(TRUE,$ligne[0]);
		
		}
		else
		{
			$this->db->db_free_result($result);
			// bug incase of bad  db design the request could return several rows
			return array(FALSE,"Error: The rubric [$rubric_id] doesn't exist. ");
		}
	
	
	}
	function get_tree_branche($ww_rubric_id)
	{
			$depth=0;
			while ($depth <= MAX_DEPTH)
			{
				//	get the previous rubrics that lead to this rubric
				//  as an array of string
					$depth++;
					$req=
					"select	
						tr_rubric_id,
						tr_sub_rubric_id,
						ru1.ru_rubric_name
					from 
						rubrictree,
						rubric as ru1
					where 
						tr_sub_rubric_id=$ww_rubric_id
						and
						tr_rubric_id=ru1.ru_rubric_id
					limit 1
					;";
					$result=$this->db->db_exec($req);
					if (!isset(	$result))
					{
						print ("Error: unpossible to execute the sql statement");
						print($this->db->db_error_msg()); 
						$this->db->db_free_result($result);
						return;
					}

					$nbr_row=$this->db->db_num_rows($result);
					if ($nbr_row != 0)
					{
						$ligne=$this->db->db_fetch_array($result);
						$ww_rubric_id=$ligne[0];
						$ww_rubric_name=$ligne[2];
						$branche_tree[]=array("$ww_rubric_id","$ww_rubric_name");
		
					}
					else
					{
						break;
					}
					
			}
			$this->db->db_free_result($result);
			if (isset($branche_tree))
			{	
				return array_reverse($branche_tree);
			}
			else
			{
				return;
			}
	}
	

	function get_sub_rubrics ($rubric_id,$sub_rubric_id=0,$max_row=20)
	{
		// request the sub_rubric linked to a rubric
		// it returns an array with two elements
		//	  first element is filled withe an array of  rubrics
		//   second one is filled with aboolean value indicating 
		//   if they are still more rows to get
		$req = $this->get_sub_rubrics_req ($rubric_id,$sub_rubric_id,$max_row);

		$result= $this->db->db_exec($req);
		$result_num=$this->db->db_num_rows($result);
		if ($result_num == 0)
		{
			return ;
		}
		else
		{	
						
			while ($ligne=$this->db->db_fetch_array($result))
			{
				// verify if they are sub rubrics for this rubric
				$req4 = $this->get_sub_rubrics_req ($ligne[0],0,1);
				
				$result2= $this->db->db_exec($req4);
					if ($this->db->db_num_rows($result2)==0)
					{ 
						$sub_rubric[]=array(0,$ligne[0], $ligne[1]);
					}
					else
					{
						$sub_rubric[]=array(1,$ligne[0], $ligne[1]);
					}
				$this->db->db_free_result($result2);
				$last_sub_rubric_id=$ligne[0];
			}
		
			$this->db->db_free_result($result);
			
			$returned_array[0]=$sub_rubric;	
			// verify if they are more row to get
			$req = $this->get_sub_rubrics_req ($rubric_id,$last_sub_rubric_id,2);
			$result=$this->db->db_exec($req);
			
			if ($this->db->db_num_rows($result) > 1)
				$returned_array[1]=array(TRUE,$last_sub_rubric_id);	
			else
				$returned_array[1]=array(FALSE,0);	
				
			$this->db->db_free_result($result);
			return $returned_array;
		}
	}
	function get_sub_rubrics_req ($rubric_id,$sub_rubric_id=0,$max_row=20)
	{
		$req=
		"select 
			tr_sub_rubric_id,
			ru1.ru_rubric_name name
		from 	
			rubrictree,
			rubric as ru1
		where 
			tr_rubric_id=$rubric_id
			and 
			tr_sub_rubric_id >= $sub_rubric_id
			and
			tr_sub_rubric_id=ru1.ru_rubric_id
			
		limit $max_row
		;";
		return $req;
	
	}
}
?>
