<?php
/*   
    
    footrack       Copyright (C)   2005 Marc Dechico
   
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

//session_start();
session_register("form_line");
session_register("datas_array");

include("utility.php");
include("utility_html.php");
include("stock_class.php");

//print("")

// opti: change the name of pgm_mod 
if(isset($_REQUEST["pgm_mod"]))
{
	$pgm_mod_nam=substr($_REQUEST["pgm_mod"],0,3);
	$pgm_mod_opt=substr($_REQUEST["pgm_mod"],3,3);
	// bug: should use the end of the string 
	$pgm_mod_arg=substr($_REQUEST["pgm_mod"],6,20);
}
else
{
	die(	
	sprint_error(
						"Error in pgm:". getenv("SCRIPT_NAME")
						."\n"."the pgm need argument named pgm_mod= cre mod or vis"
					)
		) ;
}		
		
// replace the exposant separator to permit the scanf
//$ss=str_replace("=","\t",SID);
// explode in two parts Session 
//list($ss_name,$ss_id)=sscanf($ss,"%s\t%s");
//$hidden[]="<input type='hidden' name='$ss_name' value='$ss_id'>";



switch ($pgm_mod_nam)
{
	// Create new object in stock  
	//     prepare the form to enter the datas
	case "cre":
		// opti: the var saved in session should have a special prefix
		cre($HTTP_SESSION_VARS,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg);

		break;
		
	// Modify characteristics of an object allready in stock 
	//		prepare the form to enter the datas
	case "mod":
		// opti: the var saved in session should have a special prefix
		mod($HTTP_SESSION_VARS,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg);
		break;
	// visualize (no modification) the object in stock	
	case "vis":
		// session isn't registered to force to regenerate the form
		// form the database 
		vis($HTTP_SESSION_VARS,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg);
		break;
		
	// opti : when updating or inserting I am using seesion registered datas so why should I use
	//				CGI arguments?
		
	// Modify the database to create a new object
	// This 'ins' html page come after the 'cre' (create html page)
	case 'ins':
		// opti: the var saved in session should have a special prefix
		ins($HTTP_SESSION_VARS,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg);
		break;
	
	
	// Modify the databsae to modify an object allready in stock
	case 'upd':
		upd($HTTP_SESSION_VARS,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg);
		break;
		
	default:
		die(	sprint_error
				(
					"Error in pgm:". getenv("SCRIPT_NAME")
					."\n"."pgm_mod argument must have a valid value from the list:"
					."\n"."cre, mod, vis, ins, upd"
					."\n"."for [cre]ate [mod]ify [vis]ualize [ins]sert [upd]ate"
				)
			) ;
}
function cre(& $session_vars,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg)
{
		if(isset($_REQUEST["obj_type_id"]))
		{

			// bug check if num
			
		
			$sto= new stock_new_obj($_REQUEST,$session_vars,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg);
			if ($sto->err[0])
				die(sprint_error($sto->err[1]));	
			
			if ($pgm_mod_opt=="ext")
			{
				// the user wants to extend some charaterisitc field
				// transmits the id of the characteristic given in opt_arg 
				$sto->regenerate_form_line($pgm_mod_arg);
			}
			else
			{
				$sto->get_form_line();
			}
			
			$sto->close_db();
			
			$nav[]="<input type='hidden' name='obj_type_id' value='$_REQUEST[obj_type_id]'>";
			$nav[]="<button type='submit' name='pgm_mod' value='ins'>Create</button>";
			$readonly=FALSE;
			
			print_form_line("cre",$sto,$hidden,$nav,$readonly);
		}
		else
			die(	sprint_error
					(
						"Error in pgm:". getenv("SCRIPT_NAME")
						."\n"."obj_stock_id argument must be provided in order to modify an object in stock"
					)
				) ;

}
function mod(& $session_vars,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg)
{

		if(isset($_REQUEST["obj_stock_id"]))
		{
	//		session_register("form_line");
	//		session_register("datas_array");
			// bug check if num
			$sto= new stock_new_obj($_REQUEST,$session_vars,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg);
			if ($sto->err[0])
				die(sprint_error($sto->err[1]));	
			if ($pgm_mod_opt=="ext")
			{
				$sto->regenerate_form_line($pgm_mod_arg);
			}
			else
			{
				$sto->get_form_line();
			}
			$sto->close_db();
			
			//$hidden[]="<input type='hidden' name='pgm_mod' value='updmod'>";
			$hidden[]="<input type='hidden' name='obj_stock_id' value=$_REQUEST[obj_stock_id]>";
			$nav[]="<button type='submit' name='pgm_mod' value='upd'>Modify</button>";
			$readonly=FALSE;
			
			print_form_line("mod",$sto,$hidden,$nav,$readonly);
		}
		else
			die(	sprint_error
					(
						"Error in pgm:". getenv("SCRIPT_NAME")
						."\n"."obj_stock_id argument must be provided in order to modify an object in stock"
					)
				) ;
	
}
function vis(& $session_vars,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg)
{
	if(isset($_REQUEST["obj_stock_id"]))
	{

		// bug check if num
		$sto= new stock_new_obj($_REQUEST,$session_vars,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg);	
		// opti: the var saved in session should have a special prefix

		if ($sto->err[0])
			die(	sprint_error
					(
						"Error in pgm:". getenv("SCRIPT_NAME")
						."\n".$sto->err[1]
					)
				) ;
		
		$sto->get_form_line();
		$sto->close_db();
		
		$hidden[]="<input type='hidden' name='obj_stock_id' value=$_REQUEST[obj_stock_id]>";
		$nav[]="<button type='submit' name='pgm_mod' value='mod'>Modify</button>";
		$readonly=TRUE;
		
		print_form_line("vis",$sto,$hidden,$nav,$readonly);
	}
	else
		die(	sprint_error
				(
					"Error in pgm:". getenv("SCRIPT_NAME")
					."\n"."argument obj_stock_id must be provided"
				)
			) ;

}
function ins(& $session_vars,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg)
{			
			$sto= new stock_new_obj($_REQUEST,$session_vars,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg);
			if ($sto->err[0])
				die(	sprint_error
						(
							"Error in pgm:". getenv("SCRIPT_NAME")
							."\n".$sto->err[1]
						)
					) ;
			
		$err=$sto->validate_form();
			if($err[0])
			{
				// the value choosen by the user are incorrect
				if (isset($_REQUEST['obj_type_id']))
					$hidden[]="<input type='hidden' name='obj_type_id' value='$_REQUEST[obj_type_id]'>";
				
				$nav[]="<button type='submit' name='pgm_mod' value='ins'>Create</button>";
					
				$readonly=FALSE;
				$message="You have to correct the value you entered";
				
				print_form_line("cre",$sto,$hidden,$nav,$readonly);
				
			}
			else
			{
				// the values are correct update the database
				$sto->db_insert();
				if($sto->err[0])
				{
					die(	sprint_error
							(
								"Error in pgm:". getenv("SCRIPT_NAME")
								."\n".$sto->err[1]
							)
						) ;
				
				}
				else
				{
				// bug :to review !!
					if (isset($sto->obj_stock_id))
						$hidden[]="<input type='hidden' name='obj_stock_id' value='$sto->obj_stock_id'>";
					$nav[]="<button type='submit' name='pgm_mod' value='mod'>Modify</button>";
					$readonly=TRUE;
					$message="The new object has been successfully insserted in the database
								You can still modify it";
					print_form_line("vis",$sto,$hidden,$nav,$readonly,$message);
				}
			}
			$sto->close_db();
}
function upd( $session_vars,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg)
{

	if (isset($_REQUEST['obj_stock_id']))
		$hidden[]="<input type='hidden' name='obj_stock_id' value='$_REQUEST[obj_stock_id]'>";
	$sto= new stock_new_obj($_REQUEST,$session_vars,$pgm_mod_nam,$pgm_mod_opt,$pgm_mod_arg);
	if ($sto->err[0])
		die(	sprint_error
				(
					"Error in pgm:". getenv("SCRIPT_NAME")
					."\n".$sto->err[1]
				)
			) ;
	// debug 
	//print_r($sto->form_line);
	//$w=sprintf("%d",$sto->form_line[0][0]);
	$err=$sto->validate_form();
	if($err[0])
	{
		// datas entered in hte form are not valid 
		$sto->close_db();
		$nav[]="<button type='submit' name='pgm_mod' value='updcor'>Modify</button>";
		$readonly=FALSE;
		$message="What you have typed is not valid, correct it please";
		print_form_line("mod",$sto,$hidden,$nav,$readonly,$message);
	}
	else
	{	
		// datas entered are correct
		$ret=$sto->db_update($pgm_mod_opt);
		// bug: check error and print it 
		$sto->close_db();
		switch ($ret)
		{
		
			case "CONFIRMATION":
						
				// the data have been modified in another pgm instance since retrived 
				// by this pgm instance (concurrent database modification)
				$nav[]="<button type='submit' name='pgm_mod' value='updovr'>Overwrite</button>";
				$nav[]="<button type='submit' name='pgm_mod' value='updkee'>Modify and keep new modification in database</button>";
				$nav[]="<button type='submit' name='pgm_mod' value='mod'>Restart from database stat</button>";
				$readonly=FALSE;
				$message="Data have been modified in the database since you began to start the modification";
				print_form_line("mod",$sto,$hidden,$nav,$readonly,$message);
				break;
			
			case "DELETED":
				
				die(	sprint_error
						(
							"Error in pgm:". getenv("SCRIPT_NAME")
							."\n". $sto->err[1]
						)
					) ;
				break;
			default: 				
			
				$ww_obj_id=$_REQUEST['obj_stock_id'];
				Header("Location:stock.php?pgm_mod=vis&obj_stock_id=$ww_obj_id");
		}

	}			

}
function print_form_line($pgm_mod_nam,& $sto,& $hidden,& $nav,$readonly,$message="")
{
	if ($readonly) 
		$readattribut="readonly";
	else
		$readattribut="";
	
	print_header();
	if($message!="") print(nl2br($message));


	print("\n<form method=post action='stock.php'>");	
	
	for($i=0;$i<count($hidden);$i++)
	{
		print ("\n".$hidden[$i]);
	}
	print("\n<table>");
	
	print("\n\t<tbody>");
	if ($pgm_mod_nam != "cre")
	{
			print("\n<tr>");
		
				print("\n\t<td>");
				print("\n\t</td>");
				
				print("\n\t<td>");
					print("Id");
				print("\n\t</td>");
				
				print("\n\t<td>");
					print("$sto->obj_stock_id");
				print("\n\t</td>");
			print("\n</tr>");
	}
	
	$form_line=& $sto->form_line;
	$max_i=count($form_line);
	for($i=0;$i<$max_i;$i++)
	{
		
			/*
				0- 	The database column name or the id of the characteristic describing 
						the dynamic column 
				1- 	If the field must be filled (true/false)
				2- 	The field label to be printed 
				3- 	The type of entry (in the form : text , radio....)
				4- 	The type of data  (decimal, text, float)
				5- 	The length including decimal
				6- 	The number of decimal
				7- 	A list of [values,codes] permitted for this characteristic
				8- 	The value of the characteristic
				9- 	A list [code,abbr,value] permitted  for the coeff-unit  
				10- 	The Id  for the coeff-unit
				11-   Error message if data entered is wrong
				12-	Decimal control type (array including 1-type [none,range,unsigned]  2-min_range 3-max_range)
				13- 	Saved initial value from database
				14-	Saved initial coeff_unit value from database 
				15-	Value Modified TRUE/FALSE 
				16-   Coeff Modified TRUE/FALSE
				17- 	Characteristic occurence (as a part of the key)
				18-	multi occurence allowed (true/false)
				19-	initial occurence number of occurence presented for a creation or occurence extension
			*/

		// do not print line with no values when readonly
		if(!$readonly || $form_line[$i][8]!="")
		{						
			print("\n<tr>");
		
				print("\n\t<td>");
				if (!$readonly && $form_line[$i][1])	print("*");

							
				print("\n\t</td>");
				print("\n\t<td>");
					print($form_line[$i][2]);
					if (!$readonly && $form_line[$i][4]=="decimal")
					{
						$max_int=$form_line[$i][5]-$form_line[$i][6];
						printf("[%d,%d]",$max_int,$form_line[$i][6]);
					}
				print("\n\t</td>");
				print("\n\t<td align='left'>");
				//print("\n");
				$maxlength=0;
					// 
					switch ($form_line[$i][3])
					{
						case "text":
							switch ($form_line[$i][4])
							{
								case "decimal":
									//  one position for the sign separator
									$maxlength=$form_line[$i][5]+1;
									// sevearal for the "thousand" separator
									$maxlength+=floor(($form_line[$i][5]-$form_line[$i][6])/3);
									//  one position for the decimal separator
									if ($form_line[$i][6]>0) $maxlength++;
									break;
								case	"text":
									$maxlength=$form_line[$i][5];
									break;
								
								case	"float":
									$maxlength=$form_line[$i][5];
									break;
								
								case	"object_id":									
									$maxlength=$form_line[$i][5];
									break;
								default:
								
							}
						
							if ($maxlength<=80) 
								$size=$maxlength;
							else
								$size=40;
								
							printf(
							"\n\t\t<input type='text' name='%s'	value='%s' maxlength='%s' size='%s' $readattribut>",
							$form_line[$i][0]."_".$form_line[$i][17],
							convert_html($form_line[$i][8]),
							$maxlength,
							$size
							);					
							break;
							
						case "radio":
							if($readonly)
							{
								foreach($form_line[$i][7] as $radio_value=>$radio_id)
								{				
									
									if ($radio_value==$form_line[$i][8])
									{	
										$radio_value=convert_html($radio_value);
										print(" ($radio_value)");
									}
									else
									{
										$radio_value=convert_html($radio_value);
										print(" $radio_value");
									}
								}
							}
							else
							{
								foreach($form_line[$i][7] as $radio_value=>$radio_id)
								{				
									if ($radio_value==$form_line[$i][8])
										$checked="checked";
									else
										$checked="";
										
									$radio_value=convert_html($radio_value);
									print("\n\t\t<input type='radio' name='".
											$form_line[$i][0]."_".$form_line[$i][17].
											"' value='$radio_value' $checked > $radio_value");					
								}
							}
							break;
						
						case "select":
							// the navigator doesn't accept selected 
							// so I have to pick up the value and put it in the first place
							if ($readonly)
							{
								printf(
								"\n\t\t<input type='text' name='%s'	value='%s' size='%s' readonly>",
								$form_line[$i][0]."_".$form_line[$i][17],
								convert_html($form_line[$i][8]),
								strlen($form_line[$i][8])
							);					
							//print("$form_line[$i][8]");
							}
							else
							{
								print("\n\t\t<select name='".$form_line[$i][0]."_".$form_line[$i][17]."' >");
								if($form_line[$i][8]!="")
								{
									// "select" the value previously chosen and stored in $form_line[$i][8] 
									$value=convert_html($form_line[$i][8]);
									print("\n\t\t\t<option value='$value'> $value </option>");					
									
								}
								foreach(array_keys($form_line[$i][7]) as $value)
								{
									if ($value != $form_line[$i][8])
									{
										$value=convert_html($value);
										print("\n\t\t\t<option value='$value'> $value </option>");
									}					
								}
								print("\n\t\t</select>");								
							}
							break;
						default:
							break;	
					
					}
					if ($form_line[$i][4]=="decimal" ||$form_line[$i][4]=="float")
				
					{
						if (count($form_line[$i][9])>1)
						{	
							if($readonly)
							{
								if($form_line[$i][10]!="")
								{
									$coeff_value=$form_line[$i][9][$form_line[$i][10]];
								}
								else
								{
									$coeff=each($form_line[$i][9]);
									$coeff_value=$coeff[1];
								
								}
								printf(
								"\n\t\t<input type='text' name='%s'	value='%s' size='%s' readonly>",
								$form_line[$i][0]."_".$form_line[$i][17],
								$coeff_value,
								strlen($coeff_value)
								);					
								
							}
							else
							{
								// the navigator doesn't accept selected 
								// so I have to pick up the value and put it in the first place
								printf("\n\t\t<select name='%s_coeff_id' $readattribut>",$form_line[$i][0]."_".$form_line[$i][17]);
								if($form_line[$i][10]!="")
								{
									// "select" the value previously chosen and stored in $form_line[$i][10] 
									$coeff_value=$form_line[$i][9][$form_line[$i][10]];
									print("\n\t\t\t<option value='".$form_line[$i][10]."' >$coeff_value </option>");					
								}
								foreach($form_line[$i][9] as $coeff_id=>$coeff_value)
								{
									if ($coeff_id!=$form_line[$i][10])
										print("\n\t\t\t<option value='$coeff_id' > $coeff_value</option>");					
								}
								print("\n\t\t</select>");								
								}
						}
						else
						{
							if (isset($form_line[$i][9]))
							{
							$first_unit=each($form_line[$i][9]);
							print("$first_unit[1]");
							print("\n\t\t<hidden name='".$form_line[$i][0]."_".$form_line[$i][17]."_coeff_id' value='$first_unit[0]'>");
							}
						}
					}
						
			print("\n\t</td>");	
			// print the extension icon on the last occurence line if needed
			if (!$readonly  && $form_line[$i][18])
			{
				if (	
						$i<$max_i-1
						&&
						$form_line[$i][0]!=$form_line[$i+1][0]
						||
						$i==$max_i-1
					)
				{
					print("\n\t<td>");	
						// say to call again this pgm with the same mode and to extend this current line
						// it will be checked again a the beginning of the pgm to regenerate the form 
						print("\n\t\t<button type='submit' name='pgm_mod' value='".$pgm_mod_nam."ext".$form_line[$i][0]."'>");
						print("<img src='img/extend2.png'></button>");
	//					print("ext</button>");
					print("\n\t</td>");			
				}
			}				
					
				
			print("\n</tr>");
			
			if (isset($form_line[$i][11]) && $form_line[$i][11]!="") 
			{
				print("\n<tr>");
					print("<td></td><td></td>");
					print("\n\t<td color=>");
						print_error($form_line[$i][11]);
					print("\n\t</td>");	
				print("\n</tr>");
			}
			if (isset($form_line[$i][23]) && $form_line[$i][23]!="") 
			{
				print("\n<tr>");
					print("<td></td><td></td>");
					print("\n\t<td color=>");
						print_error($form_line[$i][23]);
					print("\n\t</td>");	
				print("\n</tr>");
			}
			if($readonly && $form_line[$i][4]=="object_id")
			{
				$ww_fra_obj_id=$form_line[$i][8];
				print("\n<tr>");
					print("\n\n<TD colspan='3'>");
					print("\n\n<iframe src='stock.php?pgm_mod=vis_fra&obj_stock_id=$ww_fra_obj_id' scrolling='yes'>
								iframe for oject id
								</iframe>"
							);		
					print("\n\n</TD>");
				print("\n</tr>");
			}
		}
	}
	print("\n\t</tbody>");
	print("\n</table>");
	// print the submit button  
	for ($i=0;$i<count($nav);$i++)
	{
		print ("\n".$nav[$i]);
	}	
	?>
</FORM>
	<?php
	
	print_footer();
}
function print_header()
{
	?>
	<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
	<html>
	
	<head>
	
	<title></title>
	<meta name="GENERATOR" content="Quanta Plus">
	<meta http-equiv="Content-Type" 
			content="text/html; 	charset=iso-8859-1"
	>
	<link rel="STYLESHEET" type="text/css" media="screen"
 	href="css/style.css">

	</head>
	<body>
	<?php
}
function print_footer()
{
	?>
	</body>
	</html>
	
	<?php
}

?>
