<?php
/*   
    
    footrack       Copyright (C)   2005 Marc Dechico
   
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>

<head>
  <title></title>
  <meta name="GENERATOR" content="Quanta Plus">
</head>
<body>


<?php
// Creation de la base de donn�

include_once("utility.php");
include_once("utility_html.php");

// create the class database 
$db_conf=get_db_conf_file("db/db_conf.txt");
// new_db_class isn't a constructor but an utility that is generating a class name
// and create an instance of it 
if (!isset($db))
{
	
	$db=new_db_class($db_conf);
	if ($err[0])
	{
	
		die(	
		sprint_error(
							"Error in pgm:". getenv("SCRIPT_NAME")
							."\n"
							."Can not create the database interface class with the configuration file $db_conf"
						)
			);
		
	}
	else
	{
			print ("<br>db class creation ok");
	}
	// connect to the database
	$db->db_connect();
	if ($db->err[0])
	{
		die(	
		sprint_error(
							"Error in pgm:". getenv("SCRIPT_NAME")
							."\n"
							."Can not connect to the database see the application log-file"
						)
			);	
			
		
	}
	else
	{
			print ("<br>db connection ok");
	}
}
$table_column=array
(
"users" =>				"	us_user_id,
								us_user_name",
"rubric"=>				"	ru_rubric_id,
								ru_rubric_name",
"rubrictree"=>			"	tr_rubric_id,
								tr_sub_rubric_id",
"characteristic"=>	"	ch_charac_id,
								ch_charac_name,
								ch_input_html_type,
								ch_charac_type,
								ch_input_length,
								ch_input_decimal,
								ch_min_range,
								ch_max_range,
								ch_unit_id,
								ch_ctl_type",
"input_values"=>		"	iv_input_values_id,
								iv_charac_id,
								iv_sequence,
								iv_input_values",
"unit"=>					"	un_unit_id,
								un_unit_name",
"coeff_unit"=>			"	cu_coeff_unit_id,
								cu_unit_id,
								cu_sequence,
								cu_abbrev,
								cu_coeff_value",
"obj_type"=>			"	ot_obj_type_id,
								ot_obj_name,
								ot_rubric_id",
"obj_charac"=>			"	oc_obj_type_id,
								oc_sequence,
								oc_charac_id,
								oc_required,
								oc_multi_occur,
								oc_init_occur"
);

foreach($table_column as $table=>$column)
{ 

switch ($db->db_manufacturer)
{
	case 'mysql':
		$req="load data infile '/var/www/html/footrack/db/db_data_$table.txt' into table $table fields terminated by ';' ($column) ;";
		break;
		
	case 'postgree':
		$req="copy $table ($column) from '/var/www/html/footrack/db/db_data_$table.txt' with delimiter as ';';";
		break;
	default:
		break;
}




	print("<hr>");
	$db->db_exec_no_trigger($req);
	if (!$db->err[0])
	{
		print ("<br>Import of table: $table is ok");
	}
	else
	{
		$err_txt=$db->err[1];
		print("<br>Error Import of table: $table : 
				<br> request 
				<br> $req 
				<br> errormsg: 
				<br> $err_txt");
	}

	
}

?>

</body>
</html>
